/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem E. Exact Measurement                                   */
/*                                                                */
/* Original idea         Pavel Mavrin                             */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class exact_gk {
    static Scanner in;
    static PrintWriter out;

    class Box implements Comparable<Box> {
        int i;
        long k;
        long w;
        long q;
        long t;
        boolean u;

        Box(int i, long k, long q) {
            this.i = i;
            this.k = k;
            this.q = q;
            w = 1;
            for (int j = 0; j < k; j++) {
                w *= 10;
            }
            t = q * w;
        }


        @Override
        public int compareTo(final Box that) {
            return Long.compare(that.t, this.t);
        }
    }

    void run() {
        long x = in.nextLong();
        int n = in.nextInt();
        Box[] boxes = new Box[n];
        for (int i = 0; i < n; i++) {
            boxes[i] = new Box(i, in.nextLong(), in.nextLong());
        }
        Arrays.sort(boxes);

        int c = 0;
        long bound = x;

        loop: for (long w = 1; w > 0; w *= 10) {
            bound = bound / (w * 10) * w * 10;
            if (x <= bound) {
                continue;
            }
            for (Box box : boxes) {
                if (!box.u && box.w <= w) {
                    box.u = true;
                    c++;
                    x -= box.t;
                    if (x <= bound) {
                        continue loop;
                    }
                }
            }
            out.println(-1);
            return;
        }

        out.println(c);
        for (final Box box : boxes) {
            if (box.u) {
                out.println(box.i + 1);
            }
        }
    }

    static class Scanner {
        final BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        public Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        public void close() {
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("exact.in"));
        out = new PrintWriter("exact.out");

        new exact_gk().run();

        in.close();
        out.close();
    }
}

