/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem J. Jumping Around                                      */
/*                                                                */
/* Original idea         Andrey Stankevich                        */
/* Problem statement     Andrey Stankevich                        */
/* Test set              Andrey Stankevich                        */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Egor Kulikov                             */
/******************************************************************/

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author egor@egork.net
 */
public class jumping_kulikov {
	static final String ID = "jumping";

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(ID + ".in"));
		PrintWriter out = new PrintWriter(ID + ".out");
		new jumping_kulikov().solve(in, out);
		in.close();
		out.close();
	}

	private void solve(Scanner in, PrintWriter out) {
		int testCount = in.nextInt();
		for (int i = 0; i < testCount; i++) {
			int a = in.nextInt();
			int b = in.nextInt();
			int c = in.nextInt();
			int count = a + b + c + 1;
			int[] path = new int[count];
			int third = c / 3;
			int current = 0;
			int step = 1;
			if (c % 3 == 0) {
				for (int j = 0; j < third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
				current++;
				path[step++] = current;
				a--;
				for (int j = 0; j < third; j++) {
					current -= 3;
					path[step++] = current;
					c--;
				}
				current++;
				path[step++] = current;
				a--;
				for (int j = 0; j < third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
			} else if (c % 3 == 1) {
				for (int j = 0; j <= third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
				current -= 2;
				path[step++] = current;
				b--;
				for (int j = 0; j < third; j++) {
					current -= 3;
					path[step++] = current;
					c--;
				}
				current++;
				path[step++] = current;
				a--;
				for (int j = 0; j < third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
				current += 2;
				path[step++] = current;
				b--;
			} else {
				for (int j = 0; j <= third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
				current--;
				path[step++] = current;
				a--;
				for (int j = 0; j < third; j++) {
					current -= 3;
					path[step++] = current;
					c--;
				}
				current--;
				path[step++] = current;
				a--;
				for (int j = 0; j <= third; j++) {
					current += 3;
					path[step++] = current;
					c--;
				}
			}
			while (a > 1) {
				current++;
				path[step++] = current;
				a--;
			}
			while (current + 2 < count) {
				current += 2;
				path[step++] = current;
				b--;
			}
			if (current == count - 1)
				current--;
			else
				current++;
			path[step++] = current;
			a--;
			while (b > 0) {
				current -= 2;
				path[step++] = current;
				b--;
			}
			out.print(path[0]);
			for (int j = 1; j < count; j++)
				out.print(" " + path[j]);
			out.println();
		}
	}
}

